/***************************************************************************
 * $Id: tork.cpp,v 1.160 2007/12/30 12:58:22 hoganrobert Exp $
 *   Copyright (C) 2006 by Robert Hogan                                    *
 *   robert@roberthogan.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.              *
 ***************************************************************************/

#ifndef _app_H_
#define _app_H_

#include <qstring.h>
#include <qcstring.h>

#include <stdio.h>

#include <kio/tcpslavebase.h>

#include <kurl.h>
#include <kio/global.h>
#include <kio/slavebase.h>

#include "appimpl.h"

class QCString;

class kio_appProtocol : public KIO::SlaveBase
{
public:
    kio_appProtocol(const QCString &pool_socket, const QCString &app_socket);
    virtual ~kio_appProtocol();
    virtual void listDir(const KURL & url);
    virtual void stat(const KURL & url);

private:
	void listRoot();
    void listAppContents(const QString &name);
	AppImpl m_impl;
};

#endif
